// Code generated by goa v3.8.5, DO NOT EDIT.
//
// signer service
//
// Command:
// $ goa gen
// gitlab.com/gaia-x/data-infrastructure-federation-services/tsa/signer/design

package signer

import (
	"context"
)

// Signer service makes digital signatures and proofs for verifiable
// credentials and presentations.
type Service interface {
	// Namespaces returns all keys namespaces, which corresponds to enabled Vault
	// transit engines.
	Namespaces(context.Context) (res []string, err error)
	// NamespaceKeys returns all keys in a given namespace.
	NamespaceKeys(context.Context, *NamespaceKeysRequest) (res []string, err error)
	// VerificationMethod returns a single public key formatted as DID verification
	// method for a given namespace, key and did.
	VerificationMethod(context.Context, *VerificationMethodRequest) (res *DIDVerificationMethod, err error)
	// VerificationMethods returns all public keys in a given namespace. The result
	// is formatted as array of DID verification methods with their controller
	// attribute being the given DID in the request.
	VerificationMethods(context.Context, *VerificationMethodsRequest) (res []*DIDVerificationMethod, err error)
	// CredentialProof adds a proof to a given Verifiable Credential.
	CredentialProof(context.Context, *CredentialProofRequest) (res interface{}, err error)
	// PresentationProof adds a proof to a given Verifiable Presentation.
	PresentationProof(context.Context, *PresentationProofRequest) (res interface{}, err error)
	// CreatePresentation creates VP with proof from raw JSON data.
	CreatePresentation(context.Context, *CreatePresentationRequest) (res interface{}, err error)
	// VerifyCredential verifies the proof of a Verifiable Credential.
	VerifyCredential(context.Context, *VerifyCredentialRequest) (res *VerifyResult, err error)
	// VerifyPresentation verifies the proof of a Verifiable Presentation.
	VerifyPresentation(context.Context, *VerifyPresentationRequest) (res *VerifyResult, err error)
}

// ServiceName is the name of the service as defined in the design. This is the
// same value that is set in the endpoint request contexts under the ServiceKey
// key.
const ServiceName = "signer"

// MethodNames lists the service method names as defined in the design. These
// are the same values that are set in the endpoint request contexts under the
// MethodKey key.
var MethodNames = [9]string{"Namespaces", "NamespaceKeys", "VerificationMethod", "VerificationMethods", "CredentialProof", "PresentationProof", "CreatePresentation", "VerifyCredential", "VerifyPresentation"}

// CreatePresentationRequest is the payload type of the signer service
// CreatePresentation method.
type CreatePresentationRequest struct {
	// Issuer DID of the Verifiable Presentation.
	Issuer string
	// Key namespace.
	Namespace string
	// Key to use for the proof signature.
	Key string
	// Raw JSON to be included inside the VP as Verifiable Credential.
	Data []interface{}
	// Additional JSONLD contexts to be specified in the VP.
	Context []string
}

// CredentialProofRequest is the payload type of the signer service
// CredentialProof method.
type CredentialProofRequest struct {
	// Key namespace.
	Namespace string
	// Key to use for the proof signature (optional).
	Key string
	// Verifiable Credential in JSON format.
	Credential interface{}
}

// Public Key represented as DID Verification Method.
type DIDVerificationMethod struct {
	// ID of verification method.
	ID string
	// Type of verification method key.
	Type string
	// Controller of verification method specified as DID.
	Controller string
	// Public Key encoded in JWK format.
	PublicKeyJwk interface{}
}

// NamespaceKeysRequest is the payload type of the signer service NamespaceKeys
// method.
type NamespaceKeysRequest struct {
	// Namespace for signing keys.
	Namespace string
}

// PresentationProofRequest is the payload type of the signer service
// PresentationProof method.
type PresentationProofRequest struct {
	// Issuer DID used to specify proof verification info.
	Issuer string
	// Key namespace.
	Namespace string
	// Key to use for the proof signature.
	Key string
	// Verifiable Presentation in JSON format.
	Presentation interface{}
}

// VerificationMethodRequest is the payload type of the signer service
// VerificationMethod method.
type VerificationMethodRequest struct {
	// Key namespace.
	Namespace string
	// Name of requested key.
	Key string
	// DID controller of the key.
	Did string
}

// VerificationMethodsRequest is the payload type of the signer service
// VerificationMethods method.
type VerificationMethodsRequest struct {
	// Keys namespace.
	Namespace string
	// DID controller of the keys.
	Did string
}

// VerifyCredentialRequest is the payload type of the signer service
// VerifyCredential method.
type VerifyCredentialRequest struct {
	// Verifiable Credential in JSON format.
	Credential []byte
}

// VerifyPresentationRequest is the payload type of the signer service
// VerifyPresentation method.
type VerifyPresentationRequest struct {
	// Verifiable Presentation in JSON format.
	Presentation []byte
}

// VerifyResult is the result type of the signer service VerifyCredential
// method.
type VerifyResult struct {
	// Valid specifies if the proof is successfully verified.
	Valid bool
}
